package com.steerinfo.meterwork.meterworkrailwayscheduledhelp.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkrailwayscheduledhelp.model.MeterWorkRailwayScheduledHelp;
import com.steerinfo.meterwork.meterworkrailwayscheduledhelp.service.IMeterWorkRailwayScheduledHelpService;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkRailwayScheduledHelp RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-05-15 11:24
 * 类描述
 * 修订历史：
 * 日期：2022-05-15
 * 作者：generator
 * 参考：
 * 描述：MeterWorkRailwayScheduledHelp RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkrailwayscheduledhelps")
public class MeterWorkRailwayScheduledHelpController extends BaseRESTfulController {

    @Autowired
    IMeterWorkRailwayScheduledHelpService meterWorkRailwayScheduledHelpService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayscheduledhelp:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayScheduledHelp> list = meterWorkRailwayScheduledHelpService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayscheduledhelp:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayScheduledHelp> list = meterWorkRailwayScheduledHelpService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayscheduledhelp:view")
    @GetMapping(value = "/likeByDesc")
    public RESTfulResult likeByDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayScheduledHelp> list = meterWorkRailwayScheduledHelpService.likeByDesc(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkRailwayScheduledHelp对象创建")
    @ApiImplicitParam(name = "meterWorkRailwayScheduledHelp", value = "详细实体meterWorkRailwayScheduledHelp", required = true, dataType = "MeterWorkRailwayScheduledHelp")
    //@RequiresPermissions("meterworkrailwayscheduledhelp:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkRailwayScheduledHelp model){
        RESTfulResult rm = failed();
        try {
            RESTfulResult res = meterWorkRailwayScheduledHelpService.checkAdd(model);
            return res;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
//        MeterWorkRailwayScheduledHelp meterWorkRailwayScheduledHelp = meterWorkRailwayScheduledHelpService.add(model);
//        return success(meterWorkRailwayScheduledHelp);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwayscheduledhelp:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkRailwayScheduledHelp meterWorkRailwayScheduledHelp = meterWorkRailwayScheduledHelpService.getById(id);
        return success(meterWorkRailwayScheduledHelp);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayScheduledHelp信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkRailwayScheduledHelp", value = "详细实体meterWorkRailwayScheduledHelp", required = true, dataType = "MeterWorkRailwayScheduledHelp")
    })
    //@RequiresPermissions("meterworkrailwayscheduledhelp:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkRailwayScheduledHelp model){
        model.setId(id);
        MeterWorkRailwayScheduledHelp meterWorkRailwayScheduledHelp = meterWorkRailwayScheduledHelpService.modify(model);
        return success(meterWorkRailwayScheduledHelp);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwayscheduledhelp:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkRailwayScheduledHelpService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "智能终端报警信息", notes = "智能终端报警信息")
    @PostMapping(value = "/scheduledHelp")
    public RESTfulResult scheduledHelp(@RequestBody HashMap<String, Object> param) {
        RESTfulResult rm = failed();
        String railwayNo = param.get("railwayNo") == null ? "":param.get("railwayNo").toString();
        String baseSpotNo = param.get("baseSpotNo") == null ? "" : param.get("baseSpotNo").toString();
        String baseSpotName = param.get("baseSpotName") == null ? "" : param.get("baseSpotName").toString();
        String helpContent = param.get("helpContent") == null ? "" : param.get("helpContent").toString();
        String warmType = param.get("warmType") == null ? "" : param.get("warmType").toString();
        String warmTypeName = param.get("warmTypeName") == null ? "" : param.get("warmTypeName").toString();
        try{
            if(com.steerinfo.util.StringUtils.isEmpty(railwayNo)){
                rm.setMessage("车号不能为空，请确认！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(baseSpotNo)){
                rm.setMessage("计量站点编号不能为空，请确认！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(baseSpotName)){
                rm.setMessage("计量站点名称不能为空，请确认！！");
                return rm;
            }else if(StringUtils.isEmpty(helpContent)) {
                rm.setMessage("报警信息不能为空，请确认！！");
                return rm;
            }else if(StringUtils.isEmpty(warmType)) {
                rm.setMessage("报警类型不能为空，请确认！！");
                return rm;
            }else if(StringUtils.isEmpty(warmTypeName)) {
                rm.setMessage("报警类型名称不能为空，请确认！！");
                return rm;
            }else {
                rm = meterWorkRailwayScheduledHelpService.scheduledHelp(railwayNo, baseSpotNo, baseSpotName, helpContent, warmType, warmTypeName);
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }

    @ApiOperation(value = "智能终端报警信息确认按钮", notes = "智能终端报警信息确认按钮")
    @PostMapping(value = "/scheduledHelpConfirm")
    public RESTfulResult scheduledHelpConfirm(@RequestBody HashMap params) {
        RESTfulResult rm = failed();
        String id = params.get("helpId") == null ? "": params.get("helpId").toString();
        String createNo = params.get("createNo") == null ? "" : params.get("createNo").toString();
        String createName = params.get("createName") == null ? "" : params.get("createName").toString();
        String result = params.get("result") == null ? "" : params.get("result").toString();
        try{
            if(com.steerinfo.util.StringUtils.isEmpty(id)){
                rm.setMessage("远程求助ID不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(createNo)){
                rm.setMessage("处理人编号不能为空！！");
                return rm;
            }else if(com.steerinfo.util.StringUtils.isEmpty(createName)){
                rm.setMessage("处理人名称不能为空！！");
                return rm;
            }else{
                rm = meterWorkRailwayScheduledHelpService.scheduledHelpConfirm(id, createNo, createName, result);
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }


}
